Bug 1253889 - Trips up parsing output from ldconfig -pN on proprietary (NVIDIA) libraries
Trips up parsing output from ldconfig -pN on proprietary (NVIDIA) libraries
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: dracut (Show other bugs)
21
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: dracut-maint-list
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-08-15 00:18 EDT by Tyson Whitehead
Modified: 2015-12-02 13:16 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-02 09:58:03 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tyson Whitehead 2015-08-15 00:18:26 EDT
Description of problem:

I noticed my initramfs looked like so

$ ls
=>                   ABI:                  etc    Linux  run       sysroot
0x8000000000000000,  bin                   init   OS     sbin      tmp
2.2.5)               dev                   lib    proc   shutdown  usr
2.3.99)              dracut-tmpfiles.conf  lib64  root   sys       var

Running dracut in debug mode revealed this was coming from parsing the output of "ldconfig -pN".

$ dracut --debug --force --kver 4.1.4-100.fc21.x86_64
...
///usr/lib/dracut/dracut-functions.sh@133(source): ldconfig_paths
///usr/lib/dracut/dracut-functions.sh@109(ldconfig_paths): local a i
///usr/lib/dracut/dracut-functions.sh@110(ldconfig_paths): declare -A a
////usr/lib/dracut/dracut-functions.sh@112(ldconfig_paths): ldconfig -pN
////usr/lib/dracut/dracut-functions.sh@112(ldconfig_paths): grep -F '=>'
////usr/lib/dracut/dracut-functions.sh@112(ldconfig_paths): grep -E -v '/(lib|lib64|usr/lib|usr/lib64)/[^/]*$'
////usr/lib/dracut/dracut-functions.sh@112(ldconfig_paths): read a b c d
////usr/lib/dracut/dracut-functions.sh@113(ldconfig_paths): d='0x8000000000000000, OS ABI: Linux 2.3.99) => /usr/lib64/nvidia/tls'
////usr/lib/dracut/dracut-functions.sh@114(ldconfig_paths): printf '%s\n' '0x8000000000000000, OS ABI: Linux 2.3.99) => /usr/lib64/nvidia/tls'
////usr/lib/dracut/dracut-functions.sh@112(ldconfig_paths): read a b c d
////usr/lib/dracut/dracut-functions.sh@113(ldconfig_paths): d='ABI: Linux 2.2.5) => /usr/lib64/nvidia'
////usr/lib/dracut/dracut-functions.sh@114(ldconfig_paths): printf '%s\n' 'ABI: Linux 2.2.5) => /usr/lib64/nvidia'
...

Running it manually reveals the NVIDIA libraries have additional pieces of information that is presumably tripping up the parser.

$ ldconfig -pN
...
	libogg.so.0 (libc6,x86-64) => /lib64/libogg.so.0
	libnvidia-tls.so.340.29 (libc6,x86-64, hwcap: 0x8000000000000000, OS ABI: Linux 2.3.99) => /usr/lib64/nvidia/tls/libnvidia-tls.so.340.29
	libnvidia-tls.so.340.29 (libc6,x86-64, OS ABI: Linux 2.2.5) => /usr/lib64/nvidia/libnvidia-tls.so.340.29
	libnvidia-opencl.so.1 (libc6,x86-64) => /usr/lib64/nvidia/libnvidia-opencl.so.1
	libnvidia-ml.so.1 (libc6,x86-64) => /usr/lib64/nvidia/libnvidia-ml.so.1
...

Version-Release number of selected component (if applicable):

038-39.git20150518.fc21.x86_64

How reproducible:

Always

Steps to Reproduce:

1. Install NVIDIA kernel and xorg drivers from the official nvidia cuda repo http://developer.download.nvidia.com/compute/cuda/repos/fedora21/x86_64
2. Rebuild initramfs with dracut
3. Unpack initramfs and look at directory structure

Actual results:

Invalid directories like "=>", "ABI:", "0x8000000000000000", and so on.

Expected results:

Just normal linux FS directories like "bin", "lib", "etc", and so on.

Additional info:
Comment 1 Fedora Update System 2015-08-19 10:13:17 EDT
dracut-038-40.git20150819.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/dracut-038-40.git20150819.fc21
Comment 2 Fedora Update System 2015-08-22 00:19:27 EDT
dracut-038-40.git20150819.fc21 has been pushed to the Fedora 21 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update dracut'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/dracut-038-40.git20150819.fc21
Comment 3 Fedora End Of Life 2015-11-04 11:01:57 EST
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2015-12-02 09:58:11 EST
Fedora 21 changed to end-of-life (EOL) status on 2015-12-01. Fedora 21 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.